> For the complete documentation index, see [llms.txt](https://docs.novacura.com/flow-connect/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.novacura.com/flow-connect/reference/reference/designer/steps/machine-step.md).

# External system

### ![](/files/-M-okwRTn49-CDu2CaCx)  <a href="#machine-step" id="machine-step"></a>

A machine step is utilized to read or write data from/to other systems, or to modify variables in a application. Machine steps remain invisible to the operator, except when issues arise (e.g., receiving an error message from the ERP system). In case of an error in a machine step, the operator receives an error message and is directed back to the most recent user step.

Machine steps that potentially modify data in another system are termed non-reversible. Incoming connections to non-reversible machine steps are marked with an orthogonal line, indicating that the operator cannot use the back button in the flow client once this step has been successfully executed.

![](/files/-M-okzlB1or6clqsLaoV)

Avoid consecutive non-reversible Machine steps because each machine step is executed atomically, meaning any changes to underlying systems are committed as soon as the step is completed. Consequently, if a transaction has already been committed, the Flow Client cannot revert to the previous user step without risking data inconsistency. In such cases, the operator is forced to exit the application immediately.

For instance, in the example below (refer to the picture), if machine step B executes successfully but machine step C fails, the operator would be compelled to exit the application.

![](/files/-M-ol7KB9HmhTmIFTU2E)

Read more about how to connect to system [here](/flow-connect/working-with-connect/connect-to-systems.md).&#x20;


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.novacura.com/flow-connect/reference/reference/designer/steps/machine-step.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
